//image2
#include  <stdio.h>
#include <assert.h>
#include <errno.h> 
#include <stdlib.h> 
#include "list.h"
//TeteLabels de liste
 listLabels_t * teteLabels = NULL;
listLabels_t *teteLabelsOri = NULL;
 listEtats_t *teteEtats = NULL;  
 listEtats_t *teteEtatsOri = NULL;

//unsigned int nb_elementsLabels  = 0;
unsigned int nb_elementsLabels  ; //!! pr faire comprendre qil faut prendre la var globade de mainEs.l
#ifndef NDEBUG
// Nombre d'elements dans la liste 
//image0

static unsigned int alloueNo=0;
#endif //NDEBUG

#ifndef NDEBUG2
static unsigned int nb_elementsEtats  = 0; //=nb Etats de ligne - 1er pr correspondance av nb_elementsLabels
#endif //NDEBUG2


// Alloue  un element
listLabels_t *alloue(void)
{
    listLabels_t *p;

    p = (listLabels_t *)malloc(sizeof(listLabels_t));
    if (NULL == p)
    {
	return NULL;
    }
#ifndef NDEBUG
    p->suiv = p->prec = NULL;
    p->magic = ALLOUE;
#endif //NDEBUG
    alloueNo++;
    if (alloueNo==1)teteLabelsOri=p;
    
    return p;
}

//Desalloue un element 
void desalloue(listLabels_t *e)
{
// S'assurer que le parametre est valide
    assert(NULL != e);
//  S'assurer que l'element n'est pas chaine
    assert( DECHAINE == e->magic);
    assert( NULL == e->suiv);
    assert( NULL == e->prec);

//Detruire le magic number pour protection
//  contre reutilisation apres liberation

#ifndef NDEBUG
    e->magic = DESALLOUE;
#endif // NDEBUG
// Desallocation
    free(e);
}

// Insere un nouvel element en teteLabels de liste
int insere(listLabels_t *e)
{
    if (NULL == e)
    {
	errno = EINVAL;
	return -1;
    }
// S'assurer que c'est bien Un e1ement allou. mllire
    assert (ALLOUE == e->magic); 
	// S'assurer que J'e1ement n'est J1.a çeia chaine 
	assert(NULL == e->suiv);
	assert(NULL == e->prec);
	//  Si la liste est vide
	if (NULL == teteLabels)
	{
	    assert(0 == nb_elementsLabels);
	    teteLabels = e;
	    e->suiv = NULL;
	    e->prec = NULL;
	}
	else // Nouvel element dans la liste
	{
	    assert(nb_elementsLabels > 0);
	    e->suiv = teteLabels;
	    e->prec = NULL;

	    //image03
	    assert(NULL == teteLabels->prec);
	    teteLabels->prec = e;
	    teteLabels = e;
	}
#ifndef NDEBUG
	// Un element supplementaire dans la liste
	nb_elementsLabels++;  printf("\nnb_elementsLabels++++++++++++++++"); printf("\n nb_elementsLabels=%i", nb_elementsLabels) ;   

	// L'element est maintenant chaine
	e->magic = CHAINE;
#endif //NDBUG
	return 0;
}



//  Enleve un element de la liste
int enleve(listLabels_t *e)
{
    if (NULL == e)
    {
	errno = EINVAL;
	return -1;
    }
    //S'assurer que c'est bien un element alloue par nos services
    assert(CHAINE == e->magic);

    //Si ce n'est pas le dernier element de la liste if (e.>suiv)
    if (e->suiv)
    {
	e->suiv->prec = e->prec;
    }
    //  Si ce n'est pas le premier element de la liste 
    if (e->prec)
    {
	e->prec->suiv = e->suiv;
    }
    else // C'est le premier element de la lliste
    {
	assert(teteLabels == e);
	teteLabels = e->suiv;
    }
#ifndef NDEBUG
    //Un element en moins dans la liste
    nb_elementsLabels --;
    //  Changer	l'etat de l'element
    e->magic = DECHAINE;
    e->prec = e->suiv = NULL;

#endif //NDEBUG
    //  Verification du nombre d'elements dans la liste
    //par rapport a la valeur teur de teteLabels
    assert ((NULL == teteLabels ) || (nb_elementsLabels > 0));
    assert ((0 == nb_elementsLabels) || (NULL != teteLabels)); 
    
    return 0;
}

//  Affiche la liste des elements
void liste(void)
{printf("\nin liste, teteLabels->chn=%s",teteLabels->chn);
    listLabels_t *p;
    p = teteLabels;
    while (p)
    {
	//image1

	//Verifier qu'il n'yapas eu de corruption memoire 
	assert(CHAINE== p->magic);
	if (teteLabels==p)
	{
	    assert(NULL == p->prec);
	}
	else
	{
	    assert(NULL != p->prec);
	}
	printf("\nelt= %s",p->chn);
printf("\n in liste  p->chn=%p ",   p->chn);
 printf("\n  in liste  strlen(p->chn)=%i", strlen(p->chn));
	p = p->suiv;
    }
}






















// Alloue  un element
listEtats_t *alloueEtats(void)
{
    listEtats_t *p;

    p = (listEtats_t *)malloc(sizeof(listEtats_t));
    if (NULL == p)
    {
	return NULL;
    }
#ifndef NDEBUG2
    p->suiv = p->prec = NULL;
    p->magic = ALLOUEE;
#endif //NDEBUG2
    return p;
}

//Desalloue un element 
void desalloueEtats(listEtats_t *e)
{
// S'assurer que le parametre est valide
    assert(NULL != e);
//  S'assurer que l'element n'est pas chaine
    assert( DECHAINEE == e->magic);
    assert( NULL == e->suiv);
    assert( NULL == e->prec);

//Detruire le magic number pour protection
//  contre reutilisation apres liberation

#ifndef NDEBUG2
    e->magic = DESALLOUEE;
#endif // NDEBUG2
// Desallocation
    free(e);
}

// Insere un nouvel element en teteEtats de liste
int insereEtats(listEtats_t *e)
{
    if (NULL == e)
    {
	errno = EINVAL;
	return -1;
    }
// S'assurer que c'est bien Un e1ement allou. mllire
    assert (ALLOUEE == e->magic); 
	// S'assurer que J'e1ement n'est J1.a çeia chaine 
	assert(NULL == e->suiv);
	assert(NULL == e->prec);
	//  Si la liste est vide
	if (NULL == teteEtats)
	{
	    assert(0 == nb_elementsEtats);
	    teteEtats = e;
	    e->suiv = NULL;
	    e->prec = NULL;
	}
	else // Nouvel element dans la liste
	{
	    assert(nb_elementsEtats > 0);
	    e->suiv = teteEtats;
	    e->prec = NULL;

	    //image03
	    assert(NULL == teteEtats->prec);
	    teteEtats->prec = e;
	    teteEtats = e;
	}
#ifndef NDEBUG2
	// Un element supplementaire dans la liste
	nb_elementsEtats ++;

	// L'element est maintenant chaine
	e->magic = CHAINE;
#endif //NDBUG
	teteEtatsOri=teteEtats;
	return 0;
}



//  Enleve un element de la liste
int enleveEtats(listEtats_t *e)
{
    if (NULL == e)
    {
	errno = EINVAL;
	return -1;
    }
    //S'assurer que c'est bien un element alloue par nos services
    assert(CHAINEE == e->magic);

    //Si ce n'est pas le dernier element de la liste if (e.>suiv)
    if (e->suiv)
    {
	e->suiv->prec = e->prec;
    }
    //  Si ce n'est pas le premier element de la liste 
    if (e->prec)
    {
	e->prec->suiv = e->suiv;
    }
    else // C'est le premier element de la lliste
    {
	assert(teteEtats == e);
	teteEtats = e->suiv;
    }
#ifndef NDEBUG2
    //Un element en moins dans la liste
    nb_elementsEtats --;
    //  Changer	l'etat de l'element
    e->magic = DECHAINEE;
    e->prec = e->suiv = NULL;

#endif //NDEBUG2
    //  Verification du nombre d'elements dans la liste
    //par rapport a la valeur teur de teteEtats
    assert ((NULL == teteEtats ) || (nb_elementsEtats > 0));
    assert ((0 == nb_elementsEtats) || (NULL != teteEtats)); 
    
    return 0;
}

//  Affiche la liste des elements
void listeEtats(void)
{//printf("\nin liste, teteEtats->chn=%s",teteEtats->chn);
    listEtats_t *p;
    p = teteEtats;
    while (p)
    {
	//image1

	//Verifier qu'il n'yapas eu de corruption memoire 
	assert(CHAINEE== p->magic);
	if (teteEtats==p)
	{
	    assert(NULL == p->prec);
	}
	else
	{
	    assert(NULL != p->prec);
	}
	printf("\nelt= %s %s %s ",p->depar,p->etiqt,p->destin);
	//printf("\n in liste  p->chn=%p ",   p->chn);
	// printf("\n  in liste  strlen(p->chn)=%i", strlen(p->chn));
	p = p->suiv;
    }
}

